function n = FunModSNM3F(x, Weights, Tau, phaseS, F, C)

% FunModS computes the cost function for retrieval of the Fourier modules .
%
% Copyright (C) Enrico Chiovetto, 2014, enrico.chiovetto@gmail.com.
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


FUN=[];
[K,NumW]=size(C);
[NumS,NumA]=size(squeezeOne(phaseS(1,:,:)));
x=x';
for jj=1:K
FF=squeezeOne(F(jj,:,:));
for k=0:1:NumA
    A=Weights.*exp(-1i*k*Tau);
    if k==0
        for l=1:1:NumS
            for m=1:NumW
            B((l-1)*NumW+m,1)=C(jj,m)*x((l-1)*(NumA+1)+1);
            end
        end
        AUX=A*B;
        FUN=[FUN; real(AUX)-real(FF(:,k+1))];
        FUN=[FUN; imag(AUX)-imag(FF(:,k+1))];
    else
        for l=1:1:NumS
            for m=1:NumW
            B((l-1)*NumW+m,1)=C(jj,m)*x((l-1)*(NumA+1)+k+1).*(cos(phaseS(1,l,k))+1i*sin(phaseS(1,l,k)));
            end
        end
        AUX=A*B;
        FUN=[FUN; real(AUX)-real(FF(:,k+1))];
        FUN=[FUN; imag(AUX)-imag(FF(:,k+1))];
    end
end
end
n=1/2*norm(FUN,2)^2;


