function n = FunPhaseSNM3F(x, Weights, Tau, modS, F, C)

% FunModS computes the cost function for phase retrieval. 
%
% Copyright (C) Enrico Chiovetto, 2014, enrico.chiovetto@gmail.com.
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


FUN=[];
[K,NumW]=size(C);
[NumS,NumA]=size(squeezeOne(modS(1,:,:)));
NumA=NumA-1;
for jj=1:K
FF=squeezeOne(F(jj,:,:));
for k=1:1:NumA
    A=Weights.*exp(-1i*k*Tau);
    for l=1:1:NumS
        for m=1:NumW
        B((l-1)*NumW+m,1)=C(jj,m)*modS(1,l,k+1)*(cos(x((l-1)*(NumA)+k))+1i*sin(x((l-1)*(NumA)+k)));
        end
    end
    AUX=A*B;
    FUN=[FUN; (real(AUX)-real(FF(:,k+1)))];
    FUN=[FUN; (imag(AUX)-imag(FF(:,k+1)))];
end
end
n=norm(FUN,2)^2;