function [c,ceq,gradc,gradceq]=nonlinconPhaseSNM3F(x, modS, ts)

% nonlinconPhaseSNMF3F fixes constraints (non-negativity of the primitives)
% during identification of the phases of the Fourier coefficients of the
% space-by-time primitives.
%
% Copyright (C) Enrico Chiovetto, 2014, enrico.chiovetto@gmail.com.
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
% If you use this software for your research, please refer to the paper
% entitled " ",
% by Chiovetto E, d'Avella A and Giese, MA.



T=numel(ts);
[NumS,NumA]=size(squeezeOne(modS(1,:,:)));
NumA=NumA-1;
phaseS=reshape(x,NumA,NumS)';
S=squeezeOne(modS(1,:,2:NumA+1)).*exp(1i*phaseS(:,1:NumA));
temp=squeezeOne(modS(1,:,:));
Sour=repmat(temp(:,1),1,numel(ts));
for l=1:1:NumS
    for m=1:1:NumA
        Sour(l,:)=Sour(l,:)+conj(S(l,m))*exp(-1i*m*ts)+S(l,m)*exp(1i*m*ts);
    end
end

ceq=[];
c=[];
for k=1:1:NumS
    c=[c; -Sour(k,:)'];
end
if nargout > 2
    gradc = zeros(NumS*T,NumS*NumA);
    for l=1:1:NumS
        for m=1:1:NumA
            gradc((l-1)*T+1:l*T,(l-1)*NumA+m)=2*modS(1,l,m)*sin(m*ts+phaseS(l,m))';
        end
    end
   gradc=gradc';
   gradceq = [];
end