function F=squeezeOne(x)

% squeezeOne transposes a column vector after squeezing a
% 3-multidimensional % matrix x having 2 singleton dimensions. If there is
% only one singleton % dimension the function perfoms standard
% matlab squeezing.
%
% Copyright (C) Enrico Chiovetto, 2014, enrico.chiovetto@gmail.com.
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
% If you use this software for your research, please refer to the paper
% entitled " ",
% by Chiovetto E, d'Avella A and Giese, MA.

P=size(x,1);
Q=size(x,2);

if (P==1) && (Q==1)
    F=squeeze(x)';
else
    F=squeeze(x);
end
